diff scripts/backup-container.sh @ 159:303259c08b7d

DEP-12: update backup scripts
author smith@nwoca.org
date Wed, 02 Aug 2017 21:44:52 +0100
parents scripts/backup-usas.sh@334d65dac778
children 620ea742f1df
line wrap: on
line diff
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/scripts/backup-container.sh	Wed Aug 02 21:44:52 2017 +0100
@@ -0,0 +1,38 @@
+#!/bin/bash
+# Executes a database backup for the specifed database container.  
+# The current directory is expected to contaion a project configured
+# as with SSDT conventions for an application database.
+#
+# When successful, the output file will be in ./backup with the
+# container name and timestamp in the file.  The format of the output
+# is a compressed pg_dump (sql) format.
+#
+container=${1?Must provide container name to backup}
+
+source "${SSDT_SCRIPTS:-$(dirname "${BASH_SOURCE[0]}")}/.functions.sh"
+
+set -o pipefail
+mkdir -p ./backup
+backupFile=./backup/${container}.$(date +%Y-%m-%d-%H-%M-%S).backup
+
+project=$(composeGetProject $container)
+
+if [ "$project" == "" ]; then
+   echo "no project available"
+   exit 1
+fi
+
+echo "starting backup of $container for $project"
+docker-compose exec $container sh -c "gosu postgres pg_dump -Cc --if-exists --dbname=$container ; (exit $?) " > ${backupFile}
+
+if [[ $( grep --count "CREATE TABLE" ${backupFile} ) -lt 200 || $( grep --count "PostgreSQL database dump complete" ${backupFile} ) -eq 0 ]]; then
+   echo "ERROR: backup verification FAILED"
+   echo "ERROR:  $(tail ${backupFile})"
+   exit 1
+fi
+
+gzip ${backupFile}
+
+
+echo "completed backup of $container for $project to ${backupFile}"
+